
#include <ArduinoBLE.h>
#define SERVICE_UUID "19B10000-E8F2-537E-4F6C-D104768A1214"
#define ANALOG_CHARACT_UUID "19B10001-E8F2-537E-4F6C-D104768A1214"
#define CHANNEL_CHARACT_UUID "19B10002-E8F2-537E-4F6C-D104768A1214"
    	   
BLEService AnalogService(SERVICE_UUID);
BLECharacteristic AnalogChar(ANALOG_CHARACT_UUID, BLERead | BLENotify,2);
BLEByteCharacteristic ChannelChar(CHANNEL_CHARACT_UUID, BLEWrite | BLERead);   	   
    	   
BLEDescriptor AnalogDescriptor("2901","analog");
BLEDescriptor ChannelDescriptor("2901","channel");    	      
    	      
uint8_t channel;
boolean write_adr;

void setup() {
  Serial.begin(115200);
  analogReadResolution(12);
  channel = A0;
  if (!BLE.begin()) {
    Serial.println("échec du démarrage de BLE");
    while (1);
  }
  AnalogChar.addDescriptor(AnalogDescriptor);
  ChannelChar.addDescriptor(ChannelDescriptor);
  BLE.setLocalName("ADC");
  BLE.setAdvertisedService(AnalogService);
  AnalogService.addCharacteristic(AnalogChar);
  AnalogService.addCharacteristic(ChannelChar);
  BLE.addService(AnalogService);
  BLE.advertise();
  
}   	       
    	       
void loop() {
  if (write_adr) {
    Serial.print("Adresse : ");
    Serial.println(BLE.address());
  }
  BLEDevice central = BLE.central();
  if (central) {
    Serial.print("connected to central : ");
    Serial.println(central.address());
    while (central.connected()) {
        if (ChannelChar.written()) {
            Serial.println("channel char written");
            int c = ChannelChar.value();
            if ((c>=0)&&(c<=8)) {
              Serial.println(c);
              channel = A0+c;
            }
        }
        int x = analogRead(channel);
        uint8_t a[2];
        a[0] = (x >> 8) & 0xFF;
        a[1] = x & 0xFF;
        AnalogChar.writeValue(a,2);
        delay(1000);
    }
    Serial.print("Disconnected from central: ");
    Serial.println(central.address());
  }
 
}   	         
    	         